<?php

namespace App\Exports;

use Illuminate\Support\Facades\DB;
use App\Member;
use App\Donation;
use App\Conference;
//use Maatwebsite\Excel\Concerns\FromCollection;
//use Maatwebsite\Excel\Concerns\WithHeadings;
//implements FromCollection,WithHeadings
class Export 

{
    public $type;
    public function __construct($t){
      $this->type = $t;
    }
    public function collection()
    {
        switch($this->type){
            case 'Donation':
                $data = Donation::get();
                break;
            case 'Membership':
                $data = Member::get();
                break;
            case 'inperson':
            case 'virtual':
            case 'Conference':
                $data = Conference::get();
                break;
            default:
            $data = [];
            break;
        }
        return $data;
    }
    
    public function headings(): array
    {
        $data = [];
       switch($this->type){
            case 'Donation':
                $data = ['id', 'title', 'firstname', 'lastname', 'email', 'phone', 'gender', 'address', 
                'city', 'state', 'country', 'country_code', 'comments', 'action_by', 'date_paid', 'amount', 'currency', 'reference', 
                'transaction_id', 'payment_mode', 'status', 'created_at', 'updated_at'];
                break;
            case 'Membership':
                $data = ['id', 'counter', 'regtype_id', 'title', 'firstname', 'lastname', 'gender', 'email', 'phone',
                'dob', 'country', 'country_code', 'state', 'institution', 'qualif', 'specialization', 'interest', 'whatsappno', 'nationality', 'address',
                'action_by', 'reference', 'amount', 'currency', 'date_paid', 'transaction_id', 'payment_mode', 'created_at', 'updated_at'];
                break;
            case 'inperson':
            case 'virtual':
            case 'Conference':
                $data = [
                    'id', 'user_id', 'firstname', 'surname', 'othernames', 'gender', 'country', 'country_code', 'state', 'address', 'interest', 
                    'qualif', 'specialization', 'institution', 'email', 'phone', 'action_by', 'membership_id', 'membership_name', 'amount', 'currency', 
                    'date_paid', 'reference', 'transaction_id', 'payment_mode', 'status', 'conftype', 'created_at', 'updated_at'
                    ];
                break;
            default:
            $data = [];
            break;
        }
        return $data;
    }
}


?>