<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\Hash;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;

class PadaController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        // 
    }

    public function sendMail($template,$data,$email,$altemail,$subject){
        config([
            'mail.driver' => 'smtp',
            'mail.host' => 'smtp.office365.com',
            'mail.port' => 587,
            'mail.from' => [
                'address' => '',
                'name' => ''
            ],
            'mail.username'=>'',
            'mail.password'=>'',
            'mail.encryption'=>'tls'
            ]);
        Mail::send('emails.'.$template,$data,function ($m) use ($subject,$email,$altemail){
            $m->from('pada@ug.edu.gh', 'UNIVERSITY OF GHANA - PADA');
            $m->to($email)->subject($subject);
            if(!is_null($altemail) or !empty($altemail)){
                $m->cc($email)->subject($subject);
            }
          });
         if( count(Mail::failures()) > 0 ) {
                 return ['status'=>'error'];
          } else {
              return ['status'=>'success'];
          }  
    }

    public function generateKey(){
        return base64_encode(str_random(40));
    }
    public function generateRandomString($length = 12) {
        return substr(str_shuffle(str_repeat($x='0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', ceil($length/strlen($x)) )),1,$length);
   }
    public function connectToDB($table){
        return DB::connection('pada')->table($table);
    }
    public function title(){
        $title = $this->connectToDB('titles')->get();
        return response()->json(['title' => $title]);
    }

    public function country(){
        $country = $this->connectToDB('tbl_country')->get();
        return response()->json(['country' => $country]);
    }

    public function modules(){
        $modules = $this->connectToDB('modules')->get();
        return response()->json(['modules' => $modules]);
    }

    public function createUser(Request $r){
        $hash_password = Hash::make($r->input('password'));
        if($this->connectToDB('applicants')->where('email',$r->input('email'))->exists()){
            return response()->json(['status' => 'exists']);
        }
        $apikey = $this->generateKey();
        $adduser = $this->connectToDB('applicants')->insert([
            'surname'=>$r->input('surname'),
            'firstname'=>$r->input('firstname'),
             'email'=>$r->input('email'),
             'password'=>$hash_password,
             'apikey'=>$apikey
             ]);
      if($adduser){   
        $user = $this->connectToDB('applicants')->where('email',$r->input('email'))->first();
        return response()->json(['status' => 'success','msg'=>'New user created','apikey'=>$apikey,'user'=>$user]);
      }else{
        return response()->json(['status' => 'error','msg'=>'Error Creatiing User']);
      }
    }

    public function login(Request $r){
            $finduser = $this->connectToDB('applicants')->where('email',$r->input('email'))->first();
            if(is_null($finduser)){
                return response()->json(['status' => 'error','msg'=>'Invalid Username or Password1']);
            }else{
                if(Hash::check($r->password,$finduser->password)){
                    $apikey = $this->generateKey();
                    $this->connectToDB('applicants')->where('id',$finduser->id)->update(['apikey'=>$apikey]);
                    return response()->json(['status'=>'success','user'=>$finduser,'apikey'=>$apikey]);
                }else{
                    return response()->json(['status' => 'error','msg'=>'Invalid Username or Password2']);
                }
            }
    }

    public function saveInformation(Request $r){
        $newname = '';
        if ($r->hasFile('file')) { 
            $file = $r->file('file');
            $ext = $r->file('file')->extension();
            $newname = 'PADA-'.$this->generateRandomString().'.'.$ext;
            $file->move(base_path('/public/pada/docs'), $newname);
        }
        $checkifitsupdate = $this->connectToDB('applicants')->where('email',$r->input('email'))->first(['school']);
        if(true){
            $data = ['surname'=>$r->input('surname'),'firstname'=>$r->input('firstname'),'preferencemodule'=>$r->input('preferencemodule'),'preferencemodule1'=>$r->input('preferencemodule1')];
            if($r->input('school')=='1'){
                $this->sendMail('submission1',$data,$r->input('email'),$r->input('altemail'),'Confirmation of your application to the PADA June 2019 Doctoral School 1');
            }elseif($r->input('school')=='2'){
                $this->sendMail('submission2',$data,$r->input('email'),$r->input('altemail'),'Confirmation of your application to the PADA June 2019 Doctoral School 2');
            }else{
                $this->sendMail('submission1',$data,$r->input('email'),$r->input('altemail'),'Confirmation of your application to the PADA June 2019 Doctoral School 1');
                $this->sendMail('submission2',$data,$r->input('email'),$r->input('altemail'),'Confirmation of your application to the PADA June 2019 Doctoral School 2');
            }
        }

         $find = $this->connectToDB('applicants')->where('email',$r->input('email'))->update([
              'title'=>$r->input('title'),
              'surname'=>$r->input('surname'),
              'firstname'=>$r->input('firstname'),
              'gender'=>$r->input('gender'),
              'nationality'=>$r->input('nationality'),
              'nameofphdprogram'=>$r->input('nameofphdprogram'),
              'programyear'=>$r->input('programyear'),
              'universityregphd'=>$r->input('universityregphd'),
              'countrystudying'=>$r->input('countrystudying'),
              'carnegiescholarship'=>$r->input('carnegiescholarship'),
              'phone'=>$r->input('phone'),
              'email'=>$r->input('email'),
              'altphone'=>$r->input('altphone'),
              'altemail'=>$r->input('altemail'),
              'attendedpada'=>$r->input('attendedpada'),
              'modulestakenpast'=>$r->input('modulestakenpast'),
              'preferencemodule'=>$r->input('preferencemodule'),
              'preferencemodule1'=>$r->input('preferencemodule1'),
              'school'=>$r->input('school')
         ]);
         if( $newname !==''){
            $this->connectToDB('applicants')->where('email',$r->input('email'))->update([
                'academicproof'=>$newname
            ]);
         }
         $user = $this->connectToDB('applicants')->where('email',$r->input('email'))->first();
         return response()->json(['status' => 'success','user'=>$user]);
    }

    public function adminLogin(Request $r){
        $finduser = $this->connectToDB('admin')->where('username',$r->input('email'))->first();
        if(is_null($finduser)){
            return response()->json(['status' => 'error','msg'=>'Invalid Username or Password']);
        }else{
            if(Hash::check($r->password,$finduser->password)){
                $apikey = $this->generateKey();
                $this->connectToDB('admin')->where('id',$finduser->id)->update(['apikey'=>$apikey]);
                return response()->json(['status'=>'success','user'=>$finduser,'apikey'=>$apikey]);
            }else{
                return response()->json(['status' => 'error','msg'=>'Invalid Username or Password']);
            }
        }
    }

    public function fetchApplicants(){
        $finduser = $this->connectToDB('applicants')->paginate(50);
        return response()->json(['response' => $finduser]);
    }

    // please note 1 is accept and 2 is deny
    public function deny($id,$school){
        $find = $this->connectToDB('applicants')->where('id',$id)->first();
        $update = $this->connectToDB('applicants')->where('id',$id)->update([
            'status'=>2
        ]);
        if($school=='1'){
            $data = ['surname'=>$find->surname,'firstname'=>$find->firstname,'preferencemodule'=>$find->preferencemodule,'preferencemodule1'=>$find->preferencemodule1,'nationality'=>$find->nationality];
            $this->sendMail('incomplete1',$data,$find->email,$find->altemail,'Incomplete application');
        }
        if($school=='2'){
            $data = ['surname'=>$find->surname,'firstname'=>$find->firstname,'preferencemodule'=>$find->preferencemodule,'preferencemodule1'=>$find->preferencemodule1,'nationality'=>$find->nationality];
            $this->sendMail('incomplete2',$data,$find->email,$find->altemail,'Incomplete application'); 
        }
       
        return response()->json(['status' => 'success']);
    }
 
    public function accept($id,$school){
        $find = $this->connectToDB('applicants')->where('id',$id)->first(['school','nationality']);
        $update = $this->connectToDB('applicants')->where('id',$id)->update([
            'status'=>1
        ]);
        if($school=='1'){
            $data = ['surname'=>$find->surname,'firstname'=>$find->firstname,'preferencemodule'=>$find->preferencemodule,'preferencemodule1'=>$find->preferencemodule1,'nationality'=>$find->nationality];
            if($find->nationality=='Ghana'){
                $this->sendMail('acceptance1gh',$data,$find->email,$find->altemail,'Provisional acceptance to PADA School 1');
            }else{
                $this->sendMail('acceptance1foreign',$data,$find->email,$find->altemail,'Provisional acceptance to PADA School 1');
            }
           
        }
        if($school=='2'){
            $data = ['surname'=>$find->surname,'firstname'=>$find->firstname,'preferencemodule'=>$find->preferencemodule,'preferencemodule1'=>$find->preferencemodule1,'nationality'=>$find->nationality];
            if($find->nationality=='Ghana'){
                $this->sendMail('acceptance2gh',$data,$find->email,$find->altemail,'Provisional acceptance to PADA School 2'); 
            }else{
                $this->sendMail('acceptance2foreign',$data,$find->email,$find->altemail,'Provisional acceptance to PADA School 2'); 
            }
           
        }
    return response()->json(['status' => 'success']);
    }

    public function bulkAction(Request $r){
        $ids = explode(',',$r->ids);
       if($r->theaction=='dnq'){
        foreach($ids as $id){
            $find = $this->connectToDB('applicants')->where('id',trim($id))->first(['school']);
            if(!is_null($find)){
                $this->deny(trim($id),$find->school);
            }
        }
       }
       if($r->theaction=='q'){
        foreach($ids as $id){
            $find = $this->connectToDB('applicants')->where('id',trim($id))->first(['school']);
            if(!is_null($find)){
                $this->accept(trim($id),$find->school);
            }
        }
        }
        return ['status'=>'success'];
    }

    public function adminFilter(Request $r){
        $q = $this->connectToDB('applicants')->
       when(isset($r->name)&&$r->name !=='',function($query) use($r){
           return $query->where('surname','like','%'.trim($r->name).'%')->orWhere('firstname','like','%'.trim($r->name).'%');
       })
       ->when(isset($r->gender)&&$r->gender !=='',function($query) use($r){
        return $query->where('gender',$r->gender);
       })
       ->when(isset($r->email)&&$r->email !=='',function($query) use($r){
        return $query->where('email',$r->email);
       })
       ->when(isset($r->phone)&&$r->phone !=='',function($query) use($r){
        return $query->where('phone',$r->phone)->orWhere('altphone',$r->phone);
       })
       ->when(isset($r->preferencemodule)&&$r->preferencemodule !=='',function($query) use($r){
        return $query->where('preferencemodule',$r->preferencemodule);
       })
       ->when(isset($r->preferencemodule1)&&$r->preferencemodule1 !=='',function($query) use($r){
        return $query->where('preferencemodule1',$r->preferencemodule1);
       })
       ->when(isset($r->nationality)&&$r->nationality !=='',function($query) use($r){
        return $query->where('nationality',$r->nationality);
       })
       ->when(isset($r->countrystudying)&&$r->countrystudying !=='',function($query) use($r){
        return $query->where('countrystudying',$r->countrystudying);
       })
       ->get();
       
       return response()->json(['response' => $q]);
    }

    //
}
