<?php

namespace App\Http\Middleware;
use Symfony\Component\HttpFoundation\BinaryFileResponse;

use Closure;

class CorsMiddleware
{
    /**
    * Handle an incoming request.
    *
    * @param  \Illuminate\Http\Request  $request
    * @param  \Closure  $next
    * @return mixed
    */
    public function handle($request, Closure $next)
    {
        $headers = [
            //'Access-Control-Allow-Origin'      => '*',
            'Access-Control-Allow-Methods'     => 'POST, GET, OPTIONS, PUT, DELETE',
            'Access-Control-Allow-Credentials' => 'true',
            'Access-Control-Max-Age'           => '86400',
            'Access-Control-Allow-Headers'     => 'Content-Type, Authorization,X-Requested-With'
        ];

        if ($request->isMethod('OPTIONS'))
        {
            return response('OK',200)->header('Access-Control-Allow-Headers','Content-Type, Authorization,X-Requested-With');

        }

        $response = $next($request);
        //dd($response);
        if($response instanceof BinaryFileResponse){
            return $response;
        }
        foreach($headers as $key => $value)
        {
            $response->header($key, $value);
        }
     return $response;
        
}

}