<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/

$router->get('/', function () use ($router) {
   // return 'ITSEv8Engine : Deisgned by UGCS';
     // $image = SimpleSoftwareIO\QrCode\Facades\QrCode::format('png')->size(300)->generate('10001');
      //dd($image);
      //return response($image)->header('Content-type','image/png');
      //echo url('/gateway/payments/posturlresponsefromexpress');
      $html = view('try')->render();
     echo htmlspecialchars($html);
});
$router->get('/regtypes','MainController@RegTypes');
$router->get('/titles','MainController@getTitles');
$router->get('/countries','MainController@getCountries');
$router->get('/qualif','MainController@getQualification');
$router->get('/specialization','MainController@getSpecialization');
$router->post('/savetologs','MainController@saveToLogs');
$router->post('/response', ['as' => 'response', 'uses' => 'MainController@payResponse']);
$router->post('/checkmembership','MainController@checkMembership');
$router->post('/confpricing','MainController@conferencePricing');
$router->post('/getdatawithref','MainController@getDataWithRef');
$router->get('/downloadinvoice/{from}/{ref}','MainController@downloadInvoice');
$router->get('/export/{from}','MainController@exportData');
$router->get('/initpayment',['as'=>'initpayment','uses'=>'MainController@initpayment']);
$router->get('/checkout',['as'=>'checkout','uses'=>'MainController@quipuCheckout']);
$router->post('/quipusuccess',['as'=>'quipusuccess','uses'=>'MainController@quipuSuccess']);
$router->post('/momosuccess',['as'=>'momosuccess','uses'=>'MainController@momoSuccess']);
$router->post('/quipucancel',['as'=>'quipucancel','uses'=>'MainController@quipuCancel']);
$router->post('/momocancel',['as'=>'momocancel','uses'=>'MainController@momoCancel']);
$router->get('/pay',['as'=>'pay','uses'=>'MainController@pay']);
$router->get('/quipustatus','MainController@quipustatus');
$router->post('/walletnameenquiry',['as'=>'walletnameenquiry','uses'=>'MainController@walletnameenquiry']);
$router->post('/debitwallet',['as'=>'debitwallet','uses'=>'MainController@debitwallet']);
$router->post('/gettransactionstatus',['as'=>'gettransactionstatus','uses'=>'MainController@gettransactionstatus']);
$router->get('/getcropinterest','MainController@getcropinterest');


//$router->get('/payresponse','MainController@payresponse');


$router->post('/login','AdminController@authenticate');
$router->group(['middleware'=>'apikey'], function() use($router){

   $router->get('/reports','AdminController@getReports');
   
   $router->get('/members','AdminController@members');
   $router->post('/addMember','AdminController@addMember');
   $router->post('/editMember','AdminController@editMember');
   $router->post('/deleteMember','AdminController@deleteMember');

   $router->get('/today','AdminController@todayData');
   $router->get('/donations','AdminController@donations');

   $router->post('/addRegistrationType','AdminController@addRegistrationType');
   $router->post('/deleteRegistrationType','AdminController@deleteRegistrationType');
   $router->post('/editRegistrationType','AdminController@editRegistrationType');
   $router->get('/registrationType','AdminController@RegistrationType');

   $router->post('/addNewUser','AdminController@addNewUser');
   $router->post('/deleteUser','AdminController@deleteUser');
   $router->get('/users','AdminController@users');
   $router->get('/conference','AdminController@conference');

   $router->post('/getologs','AdminController@saveToLogs');

   $router->post('filterdonation','AdminController@filterdonation');
   $router->post('filtermembers','AdminController@filtermembers');
   $router->post('filterconference','AdminController@filterconference');

   $router->post('saveDonation','AdminController@saveDonation');
   $router->post('editDonation','AdminController@editDonation');

   $router->post('addNewMember','AdminController@addNewMember');
   $router->post('editMember','AdminController@editMember');

   $router->post('addConference','AdminController@addConference');
   $router->post('editConference','AdminController@editConference');

   $router->get('/generatetoken','MainController@generatetoken');
});





 